'JBBS v0.1 (Joe's BBS) - Created by Joe Harley, 2022-2023

'Hides QB64's emulated DOS output screen and uses standard OS terminal program - allows for use over SSH or Telnet
'connections
$ScreenHide
$Console
_Dest _Console

'Set window title if being run locally in a GUI
_ConsoleTitle "Joe's BBS"

Beep
Print "Welcome to..."
Print "       #               ###"
Print "       #  ####  ###### ###  ####"
Print "       # #    # #       #  #"
Print "       # #    # #####  #    ####"
Print " #     # #    # #               #"
Print " #     # #    # #          #    #"
Print "  #####   ####  ######      ####"
Print
Print " ######  ######   #####     ###"
Print " #     # #     # #     #    ###"
Print " #     # #     # #          ###"
Print " ######  ######   #####      #"
Print " #     # #     #       #"
Print " #     # #     # #     #    ###"
Print " ######  ######   #####     ###"
Print

_Delay 1

'Input username
Beep
Input "Enter a username: ", username$
Print

'Prints username
Beep
Print "Welcome, " + username$; "!"
Print

_Delay 1

'Menu + menu handler
Menu:
Beep
Print
Print "==[[ M E N U ]]=="
Print
Print "1.) Write Message"
Print "2.) Read Message"
Print "3.) Play Door Games"
Print "4.) Logout"
Print
Print "================="
Print
Input "> ", selection%
If selection% = 1 Then
    GoSub MsgWrite
ElseIf selection% = 2 Then
    GoSub MsgRead
ElseIf selection% = 3 Then
    GoSub DoorMenu
ElseIf selection% = 4 Then
    GoSub ExitMsg
End If

'Message Writing Subroutine
MsgWrite:
Beep
Input "Message Filename: (SAME AS SUBJECT BUT FILENAME COMPLIANT) ", filename$
Input "Subject: ", subject$
Input "Message Body: ", body$
Open filename$ For Output As #1
Write #1, username$, subject$, body$
Close #1
Return Menu

'Message Reading Subroutine
MsgRead:
Beep
Input "Message Filename: ", fn$
Open fn$ For Input As #2
Input #2, u$, s$, b$
Print "From: " + u$
Print "Subject: " + s$
Print "Contents: " + b$
Close #2
Return Menu

'Subroutine for Door Game Menu
DoorMenu:
Beep
Print
Print "==[[ D O O R S ]]=="
Print
Print "1.) BBS Quest!"
Print "2.) Return to main menu"
Print
Print "==================="
Input "> ", selection2%
If selection2% = 1 Then
    GoSub BBSQuest
ElseIf selection2% = 2 Then
    GoSub Menu
End If

'BBSQuest Subroutine
BBSQuest:
Beep
Print "I have yet to fully implement this into the BBS program yet. Apologies!"
Return DoorMenu

ExitMsg:
Beep
Cls
Print "[[ T H A N K  Y O U !]]"
Print "Please read!"
Print
Print "Thank you for using JBBS! I understand this program is awful, and very basic but I'm hoping to massively improve this over time."
Print "I initially wrote this as a challenge to start teaching myself QB64/QuickBasic/QB45 doing something I enjoyed."
Print "If you want to help me improve this, there is a feedback form on this program's page on my website - https://jjharley.co.uk - that you can use to send feedback."
Print "Also, if you have dared to use this in any real world application, please tell me!"
Print "Please abide by all license conditions and stay safe out there! Thanks for the support! -- Joe"
Print
End

'End of program system return. This is probably a security issue
System
